package org.jeecg.modules.fbsPuArrivalvouch.controller;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsPuArrivalvouch.entity.FbsArrivalVouchs;
import org.jeecg.modules.fbsPuArrivalvouch.mapper.FbsArrivalVouchsMapper;
import org.jeecg.modules.fbsPuArrivalvouch.service.IFbsArrivalVouchsService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.fbsQualityQualificationRate.service.IFbsQualityQualificationRateService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 采购到货退货单主表（表体）
 * @author： jeecg-boot
 * @date：   2020-10-21
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsPuArrivalvouch/fbsArrivalVouchs")
@Slf4j
public class FbsArrivalVouchsController {
	@Autowired
	private IFbsArrivalVouchsService fbsArrivalVouchsService;
	@Resource
	private FbsArrivalVouchsMapper fbsArrivalVouchsMapper;
	@Resource
	private IFbsQualityQualificationRateService iFbsQualityQualificationRateService;

	 /**
	  * 未来3天的到货计划(品质管理看板)
	  * @return
	  */
	 @RequestMapping(value = "/getWillArriveList")
	 public Result<List<FbsArrivalVouchs>> getWillArriveList(){
		 Result<List<FbsArrivalVouchs>> result=new Result<>();

		 try {
			 List<FbsArrivalVouchs> map=fbsArrivalVouchsService.getWillArriveList();

			 if(map.size() > 0){
			 	 int i = 1;
				 for(FbsArrivalVouchs o:map){
					 o.setIndex(String.valueOf(i));
					 i++;
				 }
			 }

			 result.setResult(map);
			 result.success("操作成功");

		 } catch (Exception e) {
			 e.printStackTrace();
			 result.error500("操作失败："+e.getMessage());
		 }

		 return result;
	 }

	 /**
	  * 近6个月质量目标合格率比较
	  * @return
	  */
	@RequestMapping(value = "/getLastSixMonthQualityTargetCompare")
	public Result<List<Map<String,Object>>> getLastSixMonthQualityTargetCompare(){
		Result<List<Map<String,Object>>> result=new Result<>();

		try {

			List<Map<String,Object>> map = fbsArrivalVouchsService.getLastSixMonthQualityTargetCompare();
			int percentage = fbsArrivalVouchsMapper.selectPercentage();
            if(map.size() > 0){
                for (Map<String,Object> m:map){
					BigDecimal num = new BigDecimal("0");
					BigDecimal target = new BigDecimal(m.get("target").toString());
					BigDecimal real = new BigDecimal(m.get("real").toString());
					num = real.divide(target).multiply(new BigDecimal("100"));
					m.put("real",num);
                	if(percentage > 0){
						m.put("target",percentage);
					}
                    m.put("label",m.get("month"));
                    m.put("label1", "质量目标");

                    m.put("sum1",m.get("target"));
                    m.put("label2", "合格率");
                    m.put("sum2",m.get("real"));
                }
            }

			result.setResult(map);
			result.success("操作成功");

		} catch (Exception e) {
			 e.printStackTrace();
			 result.error500("操作失败："+e.getMessage());
		 }

		 return result;
	}

	/**
	* @Author chenchuang
	* @Description //TODO 品质看板：近六个月合格率 后台维护
	* @Date 2020/11/10 11:21
	* @Param []
	* @return org.jeecg.common.api.vo.Result<java.util.List<java.util.Map<java.lang.String,java.lang.Object>>>
	*/
	 @RequestMapping(value = "/getLastSixMonthQualityTargetCompareWeb")
	 public Result<List<Map<String,Object>>> getLastSixMonthQualityTargetCompareWeb(){
		 Result<List<Map<String,Object>>> result=new Result<>();
		 try {
			 List<Map<String,Object>> map = iFbsQualityQualificationRateService.getLastSixMonthQualityTargetCompareWeb();
			 result.setResult(map);
			 result.success("操作成功");
		 } catch (Exception e) {
			 e.printStackTrace();
			 result.error500("操作失败："+e.getMessage());
		 }

		 return result;
	 }




	/**
	  * 分页列表查询
	 * @param fbsArrivalVouchs
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsArrivalVouchs>> queryPageList(FbsArrivalVouchs fbsArrivalVouchs,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsArrivalVouchs>> result = new Result<IPage<FbsArrivalVouchs>>();
		QueryWrapper<FbsArrivalVouchs> queryWrapper = QueryGenerator.initQueryWrapper(fbsArrivalVouchs, req.getParameterMap());
		Page<FbsArrivalVouchs> page = new Page<FbsArrivalVouchs>(pageNo, pageSize);
		IPage<FbsArrivalVouchs> pageList = fbsArrivalVouchsService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsArrivalVouchs
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsArrivalVouchs> add(@RequestBody FbsArrivalVouchs fbsArrivalVouchs) {
		Result<FbsArrivalVouchs> result = new Result<FbsArrivalVouchs>();
		try {
			fbsArrivalVouchsService.save(fbsArrivalVouchs);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsArrivalVouchs
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsArrivalVouchs> edit(@RequestBody FbsArrivalVouchs fbsArrivalVouchs) {
		Result<FbsArrivalVouchs> result = new Result<FbsArrivalVouchs>();
		FbsArrivalVouchs fbsArrivalVouchsEntity = fbsArrivalVouchsService.getById(fbsArrivalVouchs.getId());
		if(fbsArrivalVouchsEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsArrivalVouchsService.updateById(fbsArrivalVouchs);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsArrivalVouchs> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsArrivalVouchs> result = new Result<FbsArrivalVouchs>();
		FbsArrivalVouchs fbsArrivalVouchs = fbsArrivalVouchsService.getById(id);
		if(fbsArrivalVouchs==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsArrivalVouchsService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsArrivalVouchs> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsArrivalVouchs> result = new Result<FbsArrivalVouchs>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsArrivalVouchsService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsArrivalVouchs> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsArrivalVouchs> result = new Result<FbsArrivalVouchs>();
		FbsArrivalVouchs fbsArrivalVouchs = fbsArrivalVouchsService.getById(id);
		if(fbsArrivalVouchs==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsArrivalVouchs);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsArrivalVouchs> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsArrivalVouchs fbsArrivalVouchs = JSON.parseObject(deString, FbsArrivalVouchs.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsArrivalVouchs, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsArrivalVouchs> pageList = fbsArrivalVouchsService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "采购到货退货单主表（表体）列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsArrivalVouchs.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("采购到货退货单主表（表体）列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsArrivalVouchs> listFbsArrivalVouchss = ExcelImportUtil.importExcel(file.getInputStream(), FbsArrivalVouchs.class, params);
              for (FbsArrivalVouchs fbsArrivalVouchsExcel : listFbsArrivalVouchss) {
                  fbsArrivalVouchsService.save(fbsArrivalVouchsExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsArrivalVouchss.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
